from __future__ import division

import pygame
import pygame.locals
import pygame.mouse

from OpenGL.GL import *

import pygame_io.mouse, pygame_io.events, pygame_io.music, pygame_io.screen

class Environment(object):
	"""pygame opengl environment

	no other class should have to care about pygame. (painters' opengl_auxiliary has to use pygame image methods to avoid PIL dependency.)
	no other class but painters should do opengl stuff.
	needs a scene object connected via set_scene().
	"""
	def __init__(self, size=(800,600)):
		pygame.init()

		pygame.display.set_mode(size, pygame.locals.OPENGL|pygame.locals.DOUBLEBUF)

		pygame.mouse.set_visible(False)
		self.mouse = pygame_io.mouse.Mouse()
		self.events = pygame_io.events.Events()
		self.music = pygame_io.music.Music()
		self.screen = pygame_io.screen.Screen(size)
	
	def mainloop(self):
		while True:
			glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT)

			self.scene.step(pygame.time.get_ticks()) # call as often as possible

			pygame.display.flip()
