from __future__ import division
import sys
from modules.menu import MenuScene, MenuItem, MenuItemList, MenuItemSeparator

from util import MathTuple


from scenes import Scene
from game.gamescene import GameScene

def mainmenu(environment):
	items = MenuItemList()

	def _singleplayer(scene):
		scene.environment.scene = GameScene(scene.environment)
	items.append(MenuItem(
		label="Single player game",
		callback=_singleplayer
		))

	items.append(MenuItem(
		label="Two player game"
		))

	items.append(MenuItem(
		label="Help"
		))

	items.append(MenuItem(
		label="Game options"
		))

	items.append(MenuItemSeparator()) # separator

	def _quit(scene):
		sys.exit()
	items.append(MenuItem(
		label="Quit",
		callback=_quit
		))

	menu = MenuScene("Deus vs Deus", items, environment)

	return menu

class PauseScene(Scene):
	def __init__(self, pausedscene, message, resumethen=False):
		self.pausedscene = pausedscene
		self.resumethen = resumethen or pausedscene
		self.environment = self.pausedscene.environment
		import objects.various
		self.text = objects.various.objects.abstract.Text() # w0rst. h4ck. evar.
		self.text.text = message
		self.text.size = 10
		self.text.align = "center"
		self.text.position = MathTuple(40, -30)

	def step(self, now):
		events = self.environment.events
		for e in events.get():
			if e.type == events.KEYUP and e.key in (events.K_ESCAPE, events.K_RETURN):
				self.resumethen.last_tick = now
				self.environment.scene = self.resumethen
		if hasattr(self.pausedscene, "paint"):
			self.pausedscene.paint(0)
		else:
			self.pausedscene.step(now)
		self.environment.screen.view_area((0, 0), (80, -60), True)
		self.text.paint(0)

		# even worse hacking on... all utility functions are hidden by relative import hell
		from OpenGL.GL import *
		glColor(0,0,0,0.5)
		glBegin(GL_QUADS)
		glVertex2f(0,0)
		glVertex2f(80,0)
		glVertex2f(80,-60)
		glVertex2f(0,-60)
		glEnd()
		
