from __future__ import division
from game.objects.gameobjects import MovableGameObject
from util import MathTuple
from game.constants import *

class Anvil(MovableGameObject):
	def __init__(self, *args, **kwords):
		super(Anvil, self).__init__(*args, **kwords)
		self.go = 0
		self.jumped = 0
		self.collisionpoints = [MathTuple(x) for x in ((0,0),(1,0),(1,1),(1,0))]
		self.bounce = 0.7
		self.collided_with_player = False
		self.remove_counter = TICKS_PER_SECOND * 1.5

	def collides(self, player):
		if not self.collided_with_player:
			self.collided_with_player = True
			if self.falling:
				player.time_left -= ANVILTIMEDRAIN
				player.hurt_sound.play()
		pass # print "got ya anvil"

	def tick(self):
		if not self.falling:
			self.remove_counter -= 1
			if self.remove_counter <= 0:
				self.delete_me = True

class Lazer(MovableGameObject):
	def __init__(self, *args, **kwords):
		super(Lazer, self).__init__(*args, **kwords)
		self.go = 0
		self.collisionpoints = [MathTuple(x) for x in ((0,0),(1,0),(1,1),(1,0))]
		self.is_heavy = False

	def collides(self, player):
		player.time_left -= LAZERTIMEDRAIN
		self.delete_me = True
		pass # print "got ya lazer"

	def tick(self):
		if not self.falling:
			self.delete_me = True
